---
title: 'ARIA: feed role'
slug: Web/Accessibility/ARIA/Roles/Feed_Role
tags:
  - ARIA
  - ARIA Role
  - Reference
  - feed
---
<p>{{Page("/en-US/docs/Web/Accessibility/ARIA/Roles", "Subnav")}}</p>

<p><span class="seoSummary">A <code>feed</code> is a dynamic scrollable <code>list</code> of <code>articles</code> in which articles are added to or removed from either end of the list as the user scrolls. A <code>feed</code> enables screen readers to use the browse mode reading cursor to both read and scroll through a stream of rich content that may continue scrolling infinitely by loading more content as the user reads.</span></p>

<pre class="brush: html notranslate">&lt;section role="feed" <a class="state-reference" href="https://w3c.github.io/aria/#aria-busy">aria-busy</a>="false"&gt;
  ...
  &lt;article aria-posinset="427" aria-setsize="-1"&gt;...&lt;/article&gt;
  &lt;article aria-posinset="428" aria-setsize="-1"&gt;...&lt;/article&gt;
  &lt;article aria-posinset="429" aria-setsize="-1"&gt;...&lt;/article&gt;
  ...
&lt;/section&gt;</pre>

<h2 id="Description">Description</h2>

<div class="role-description" id="desc-feed">
<p>A feed is a page structure for a scrollable <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/list_Role">list</a> of <code><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Article_Role">articles</a></code> where scrolling may cause <span>articles</span> to be added to the top or end of the list. The list establishes an interoperability contract between the web page and assistive technologies that governs scroll interactions so that assistive technology users can read articles, jump forward and backward by article, and reliably trigger new articles to load while in reading mode. Examples include an RSS feed, news feeds, social media feeds like Facebook, Instagram or Twitter, or even a list of related products on an eCommerce page. These streams can be limited or infinite, loading more content as the user scrolls. Implementing the feed pattern allows a screen reader to reliably read and trigger the loading of feed content while in reading mode.</p>

<p>A <code>feed</code> is a container element whose children are &lt;article&gt;s or have role <code>article</code>. Each article within a feed should be focusable, with tabindex of 0 or -1. An article should be scrolled into view when it, or a descendant element, receives focus. If the addition of articles occupies the main browser thread, make sure to set <code>aria-busy="true"</code> on the feed itself, and make sure to set it back to <code>false</code> when processing ends, or the user may not see the updates.</p>

<p>To ensure good user experience, avoid inserting or removing <span>articles</span> in the middle of a <code>feed</code>, load new articles before the user has reached the end of the feed, and provide keyboard commands for moving focus among <span>articles so that</span> keyboard users can navigate through your feed. See keyboard interactions below.</p>

<p>If the number of articles is known, set <code>aria-setsize</code> on the articles themselves. However, if the total number is extremely large, indefinite, or changes often, set <code>aria-setsize="-1"</code> to indicate that the size of the feed is not known.</p>

<p>Another feature of the feed pattern is skim reading: Articles within a feed can contain both an accessible name with the <code>aria-label</code> and a description with an <code>aria-describedby,</code> suggesting to screen readers which elements to speak after the label when navigating by article. By identifying the elements inside of an article that provide the title and the primary content, assistive technologies can provide functions that enable users to jump from article to article and efficiently discern which articles they want to read.</p>

<p>The feed pattern enables reliable assistive technology reading mode interaction by establishing the following interoperability agreement between the web page and assistive technologies:</p>

<ol>
 <li>In the context of a feed, the web page code is responsible for:
  <ul>
   <li>Appropriate visual scrolling of the content based on which article contains DOM focus.</li>
   <li>Loading or removing feed articles based on which article contains DOM focus.</li>
  </ul>
 </li>
 <li>In the context of a feed, assistive technologies with a reading mode are responsible for:
  <ul>
   <li>Indicating which article contains the reading cursor by ensuring the article element or one of its descendants has DOM focus.</li>
   <li>Providing reading mode keys that move DOM focus to the next and previous articles.</li>
   <li>Providing reading mode keys for moving the reading cursor and DOM focus past the end and before the start of the feed.</li>
  </ul>
 </li>
</ol>

<section class="notoc" id="sect1">
<h3 id="Keyboard_interaction">Keyboard interaction</h3>

<p>Supporting the following, or a similar, interface is recommended when focus is inside the feed:</p>

<ul>
 <li><kbd>Page Down</kbd>: Move focus to next article.</li>
 <li><kbd>Page Up</kbd>: Move focus to previous article.</li>
 <li><kbd>Control + End</kbd>: Move focus to the first focusable element after the feed.</li>
 <li><kbd>Control + Home</kbd>: Move focus to the first focusable element before the feed.</li>
</ul>

<p>If a feed is nested within a feed, such as a comments feed within a feed of blog posts, the convention is to tab into the nested feed with the <kbd>Tab</kbd> key and to provide another key, such as  <kbd>Alt + Page Down</kbd>, to navigate from an 'outer' article to the first item in that article's nested feed. Navigate between the nested feed and main feed with <kbd>Control + End</kbd> , moving focus from the inner feed to the next article in the outer feed.</p>
</section>

<section class="notoc" id="sect2">
<h3 id="WAI-ARIA_roles_states_and_properties"><abbr title="Accessible Rich Internet Applications">WAI-ARIA</abbr> roles, states, and properties</h3>

<dl>
 <dt>aria-label</dt>
 <dd>If the feed has no visible title, the <code>feed</code> element has a label specified with <a class="property-reference" href="https://w3c.github.io/aria/#aria-label">aria-label</a>. If it does, see aria-labelledby.</dd>
 <dt>aria-labelledby</dt>
 <dd>If the feed has a visible title, the <code>feed</code> element has <a class="property-reference" href="https://w3c.github.io/aria/#aria-labelledby">aria-labelledby</a> referring to the element containing the title. If not, add an aria-label.</dd>
 <dt>aria-busy</dt>
 <dd>When busy, such as when articles are being added or removed from the <code>feed</code>, set <code><a class="state-reference" href="https://w3c.github.io/aria/#aria-busy">aria-busy=</a>"true"</code> during the update operation. Make sure it's reset to <code>false</code> when the operation is complete or the changes may not become visible.</dd>
 <dt>article</dt>
 <dd>Each section of content in a feed should be contained in an <code>&lt;article&gt;</code> or element with role <a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Article_Role">article</a>. Each <code>article</code> should have an <a class="property-reference" href="https://w3c.github.io/aria/#aria-labelledby">aria-labelledby</a> referring to the article title or other child that can serve as a distinguishing label. Each article should preferably have <a class="property-reference" href="https://w3c.github.io/aria/#aria-describedby">aria-describedby</a> referring to one or more elements inside the article that serve as the primary content of the article. Each <code>article</code> element has <a class="property-reference" href="https://w3c.github.io/aria/#aria-posinset">aria-posinset</a> set to a value that represents its position in the feed and an <a class="property-reference" href="https://w3c.github.io/aria/#aria-setsize">aria-setsize</a> set to a value that represents either the total number of articles that have been loaded or the total number in the feed, depending on which value is more helpful to users. If the total number in the feed is not known, set <code>aria-setsize="-1"</code>.</dd>
</dl>
</section>
</div>

<h3 id="Required_JavaScript_features">Required JavaScript features</h3>

<p>None, except as required by any attributes. For example, setting <code>aria-busy</code> to <code>true</code> during the update operation if needed, and then to <code>false</code> upon completion.</p>

<h2 id="Examples">Examples</h2>

<p><a href="https://w3c.github.io/aria-practices/examples/feed/feed.html">Example Implementation of Feed Pattern</a></p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
  </tr>
  <tr>
   <td>{{SpecName("ARIA","#feed","feed")}}</td>
   <td>{{Spec2('ARIA')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Screen_reader_support">Screen reader support</h2>

<p>Coming soon</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/HTML/Element/article">HTML &lt;article&gt; element</a></li>
 <li><a href="/en-US/docs/Web/HTML/Element/ul">Lists in HTML</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/Article_Role">ARIA: article role</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/ARIA/Roles/List_Role">ARIA: list role</a></li>
 <li><cite><a href="https://www.w3.org/TR/wai-aria-practices-1.1/"><abbr title="Accessible Rich Internet Applications">WAI-ARIA</abbr> Authoring Practices</a></cite> - additional details on implementing a feed design pattern.</li>
</ul>
